--
-- SetPloughBitToCultivator
--
--
-- @author John Deere 6930
-- @date 08/08/2017
--

SetPloughBitToCultivator = {};

function SetPloughBitToCultivator.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Cultivator, specializations);
end

function SetPloughBitToCultivator:preLoad(savegame)	
end

function SetPloughBitToCultivator:load(savegame)
	self.processCultivatorAreas = Utils.overwrittenFunction(self.processCultivatorAreas, SetPloughBitToCultivator.processCultivatorAreas);
	
	self.setPloughBit = Utils.getNoNil(getXMLBool(self.xmlFile, "vehicle.setPloughBit#value"), false);
end

function SetPloughBitToCultivator:delete()
end

function SetPloughBitToCultivator:mouseEvent(posX, posY, isDown, isUp, button)
end

function SetPloughBitToCultivator:keyEvent(unicode, sym, modifier, isDown)
end

function SetPloughBitToCultivator:update(dt)
end;

function SetPloughBitToCultivator:updateTick(dt)
end;

function SetPloughBitToCultivator:draw()
end;

function SetPloughBitToCultivator:processCultivatorAreas(superFunc, workAreas, limitToField, limitGrassDestructionToField, angle)
	local numAreas = table.getn(workAreas);
	local areaSum = 0;
	for i=1, numAreas do
		local x = workAreas[i][1];
		local z = workAreas[i][2];
		local x1 = workAreas[i][3];
		local z1 = workAreas[i][4];
		local x2 = workAreas[i][5];
		local z2 = workAreas[i][6];
		if self.setPloughBit then
			local x, z, widthX, widthZ, heightX, heightZ = Utils.getXZWidthAndHeight(nil, x, z, x1, z1, x2, z2);
			local detailId = g_currentMission.terrainDetailId;
			setDensityParallelogram(detailId, x, z, widthX, widthZ, heightX, heightZ, g_currentMission.ploughCounterFirstChannel, g_currentMission.ploughCounterNumChannels, 1);
		end;
		areaSum = areaSum + Utils.updateCultivatorArea(x, z, x1, z1, x2, z2, not limitToField, not limitGrassDestructionToField, angle);
	end;
	return areaSum;
end;